com.fasterxml.jackson.dataformat.cbor

## Class CBORParser

- java.lang.Object
- - com.fasterxml.jackson.core.JsonParser
  - - com.fasterxml.jackson.core.base.ParserMinimalBase
    - - com.fasterxml.jackson.dataformat.cbor.CBORParser

- All Implemented Interfaces:
    com.fasterxml.jackson.core.Versioned, Closeable, AutoCloseable

      public class CBORParser
      extends com.fasterxml.jackson.core.base.ParserMinimalBase

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `CBORParser.Feature` Enumeration that defines all togglable features for CBOR generators.

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonParser

      `com.fasterxml.jackson.core.JsonParser.NumberType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected byte[]` | `_binaryValue` We will hold on to decoded binary data, for duration of current event, so that multiple calls to `getBinaryValue(com.fasterxml.jackson.core.Base64Variant)` will not need to decode data more than once.
    `protected boolean` | `_bufferRecyclable` Flag that indicates whether the input buffer is recycable (and needs to be returned to recycler once we are done) or not.
    `protected com.fasterxml.jackson.core.util.ByteArrayBuilder` | `_byteArrayBuilder` ByteArrayBuilder is needed if 'getBinaryValue' is called.
    `protected boolean` | `_closed` Flag that indicates whether parser is closed or not.
    `protected long` | `_currInputProcessed` Number of characters/bytes that were contained in previous blocks (blocks that were already processed prior to the current buffer).
    `protected int` | `_currInputRow` Current row location of current point in input buffer, starting from 1, if available.
    `protected int` | `_currInputRowStart` Current index of the first character of the current row in input buffer.
    `protected byte[]` | `_inputBuffer` Current buffer from which data is read; generally data is read into buffer from input source, but in some cases pre-loaded buffer is handed to the parser.
    `protected int` | `_inputEnd` Index of character after last available one in the buffer.
    `protected int` | `_inputPtr` Pointer to next available character in buffer
    `protected InputStream` | `_inputStream` Input stream that can be used for reading more content, if one in use.
    `protected com.fasterxml.jackson.core.io.IOContext` | `_ioContext` I/O context for this reader.
    `protected boolean` | `_nameCopied` Flag set to indicate whether the field name is available from the name copy buffer or not (in addition to its String representation being available via read context)
    `protected char[]` | `_nameCopyBuffer` Temporary buffer that is needed if field name is accessed using `getTextCharacters()` method (instead of String returning alternatives)
    `protected BigDecimal` | `_numberBigDecimal`
    `protected BigInteger` | `_numberBigInt`
    `protected double` | `_numberDouble`
    `protected float` | `_numberFloat`
    `protected int` | `_numberInt`
    `protected long` | `_numberLong`
    `protected int` | `_numTypesValid` Bitfield that indicates which numeric representations have been calculated for the current type
    `protected com.fasterxml.jackson.core.ObjectCodec` | `_objectCodec` Codec used for data binding when (if) requested.
    `protected CBORReadContext` | `_parsingContext` Information about parser context, context in which the next token is to be parsed (root, array, object).
    `protected int` | `_quad1` Quads used for hash calculation
    `protected int` | `_quad2` Quads used for hash calculation
    `protected int` | `_quad3` Quads used for hash calculation
    `protected int[]` | `_quadBuffer` Temporary buffer used for name parsing.
    `protected com.fasterxml.jackson.core.sym.ByteQuadsCanonicalizer` | `_symbols` Symbol table that contains field names encountered so far
    `protected int` | `_tagValue` We will keep track of tag value for possible future use.
    `protected com.fasterxml.jackson.core.util.TextBuffer` | `_textBuffer` Buffer that contains contents of String values, including field names if necessary (name split across boundary, contains escape sequence, or access needed to char array)
    `protected boolean` | `_tokenIncomplete` Flag that indicates that the current token has not yet been fully processed, and needs to be finished for some access (or skipped to obtain the next token)
    `protected int` | `_tokenInputCol` Column on input row that current token starts; 0-based (although in the end it'll be converted to 1-based)
    `protected int` | `_tokenInputRow` Input row on which current token starts, 1-based
    `protected long` | `_tokenInputTotal` Total number of bytes/characters read before start of current token.
    `protected int` | `_typeByte` Type byte of the current token

    - ### Fields inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

      `_currToken, _lastClearedToken, CHAR_NULL, INT_0, INT_9, INT_APOS, INT_ASTERISK, INT_BACKSLASH, INT_COLON, INT_COMMA, INT_CR, INT_e, INT_E, INT_HASH, INT_LBRACKET, INT_LCURLY, INT_LF, INT_MINUS, INT_PERIOD, INT_PLUS, INT_QUOTE, INT_RBRACKET, INT_RCURLY, INT_SLASH, INT_SPACE, INT_TAB, MAX_ERROR_TOKEN_LENGTH, MAX_INT_D, MAX_INT_L, MAX_LONG_D, MIN_INT_D, MIN_INT_L, MIN_LONG_D, NO_BYTES, NO_INTS, NR_BIGDECIMAL, NR_BIGINT, NR_DOUBLE, NR_FLOAT, NR_INT, NR_LONG, NR_UNKNOWN`

    - ### Fields inherited from class com.fasterxml.jackson.core.JsonParser

      `_features, _requestPayload`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CBORParser(com.fasterxml.jackson.core.io.IOContext ctxt, int parserFeatures, int cborFeatures, com.fasterxml.jackson.core.ObjectCodec codec, com.fasterxml.jackson.core.sym.ByteQuadsCanonicalizer sym, InputStream in, byte[] inputBuffer, int start, int end, boolean bufferRecyclable)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `_checkNumericValue(int expType)`
    `protected void` | `_closeInput()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_decodeFieldName()`
    `protected void` | `_decodeNonStringName(int ch)` Method that handles initial token type recognition for token that has to be either FIELD_NAME or END_OBJECT.
    `protected com.fasterxml.jackson.core.JsonToken` | `_decodeUndefinedValue()` Helper method to encapsulate details of handling of mysterious `undefined` value that is allowed to be used as something encoder could not handle (as per spec), whatever the heck that should be.
    `protected byte[]` | `_finishBytes(int len)`
    `protected String` | `_finishTextToken(int ch)`
    `protected void` | `_finishToken()` Method called to finish parsing of a token so that token contents are retriable
    `protected com.fasterxml.jackson.core.util.ByteArrayBuilder` | `_getByteArrayBuilder()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleCBOREOF()`
    `protected void` | `_handleEOF()`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleTaggedArray(int tag, int len)`
    `protected com.fasterxml.jackson.core.JsonToken` | `_handleTaggedBinary(int tag)`
    `protected void` | `_invalidToken(int ch)`
    `protected void` | `_loadToHaveAtLeast(int minAvailable)` Helper method that will try to load at least specified number bytes in input buffer, possible moving existing data around if necessary
    `protected String` | `_numberToName(int ch, boolean neg)`
    `protected void` | `_releaseBuffers()` Method called to release internal buffers owned by the base reader.
    `protected void` | `_reportInvalidChar(int c)`
    `protected void` | `_reportInvalidInitial(int mask)`
    `protected void` | `_reportInvalidOther(int mask)`
    `protected void` | `_reportInvalidOther(int mask, int ptr)`
    `protected void` | `_reportUnexpectedBreak()`
    `protected void` | `_skipBytes(int len)`
    `protected void` | `_skipBytesL(long llen)`
    `protected void` | `_skipChunked(int expectedType)`
    `protected void` | `_skipIncomplete()` Method called to skip remainders of an incomplete token, when contents themselves will not be needed any more.
    `void` | `close()`
    `protected void` | `convertNumberToBigDecimal()`
    `protected void` | `convertNumberToBigInteger()`
    `protected void` | `convertNumberToDouble()`
    `protected void` | `convertNumberToFloat()`
    `protected void` | `convertNumberToInt()`
    `protected void` | `convertNumberToLong()`
    `void` | `finishToken()` Method for forcing full read of current token, even if it might otherwise only be read if data is accessed via `getText()` and similar methods.
    `BigInteger` | `getBigIntegerValue()`
    `byte[]` | `getBinaryValue(com.fasterxml.jackson.core.Base64Variant b64variant)`
    `com.fasterxml.jackson.core.ObjectCodec` | `getCodec()`
    `com.fasterxml.jackson.core.JsonLocation` | `getCurrentLocation()` Overridden since we do not really have character-based locations, but we do have byte offset to specify.
    `String` | `getCurrentName()` Method that can be called to get the name associated with the current event.
    `int` | `getCurrentTag()` Method that can be used to access tag id associated with the most recently decoded value (whether completely, for scalar values, or partially, for Objects/Arrays), if any.
    `BigDecimal` | `getDecimalValue()`
    `double` | `getDoubleValue()`
    `Object` | `getEmbeddedObject()`
    `float` | `getFloatValue()`
    `int` | `getFormatFeatures()`
    `Object` | `getInputSource()`
    `int` | `getIntValue()`
    `long` | `getLongValue()`
    `com.fasterxml.jackson.core.JsonParser.NumberType` | `getNumberType()`
    `Number` | `getNumberValue()`
    `CBORReadContext` | `getParsingContext()`
    `String` | `getText()` Method for accessing textual representation of the current event; if no current event (before first call to `nextToken()`, or after encountering end-of-input), returns null.
    `int` | `getText(Writer writer)`
    `char[]` | `getTextCharacters()`
    `int` | `getTextLength()`
    `int` | `getTextOffset()`
    `com.fasterxml.jackson.core.JsonLocation` | `getTokenLocation()` Overridden since we do not really have character-based locations, but we do have byte offset to specify.
    `String` | `getValueAsString()`
    `String` | `getValueAsString(String defaultValue)`
    `boolean` | `hasTextCharacters()`
    `boolean` | `isClosed()`
    `boolean` | `isNaN()`
    `protected boolean` | `loadMore()`
    `protected void` | `loadMoreGuaranteed()`
    `Boolean` | `nextBooleanValue()`
    `String` | `nextFieldName()`
    `boolean` | `nextFieldName(com.fasterxml.jackson.core.SerializableString str)`
    `int` | `nextIntValue(int defaultValue)`
    `long` | `nextLongValue(long defaultValue)`
    `String` | `nextTextValue()`
    `com.fasterxml.jackson.core.JsonToken` | `nextToken()`
    `void` | `overrideCurrentName(String name)`
    `int` | `readBinaryValue(com.fasterxml.jackson.core.Base64Variant b64variant, OutputStream out)`
    `int` | `releaseBuffered(OutputStream out)`
    `void` | `setCodec(com.fasterxml.jackson.core.ObjectCodec c)`
    `com.fasterxml.jackson.core.Version` | `version()`

    - ### Methods inherited from class com.fasterxml.jackson.core.base.ParserMinimalBase

      `_ascii, _asciiBytes, _constructError, _decodeBase64, _getCharDesc, _hasTextualNull, _longIntegerDesc, _longNumberDesc, _reportError, _reportError, _reportError, _reportInputCoercion, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOF, _reportInvalidEOFInValue, _reportInvalidEOFInValue, _reportMissingRootWS, _reportUnexpectedChar, _throwInternal, _throwInvalidSpace, _wrapError, clearCurrentToken, currentToken, currentTokenId, getCurrentToken, getCurrentTokenId, getLastClearedToken, getValueAsBoolean, getValueAsDouble, getValueAsInt, getValueAsInt, getValueAsLong, getValueAsLong, hasCurrentToken, hasToken, hasTokenId, isExpectedStartArrayToken, isExpectedStartObjectToken, nextValue, reportInvalidNumber, reportOverflowInt, reportOverflowInt, reportOverflowInt, reportOverflowLong, reportOverflowLong, reportOverflowLong, reportUnexpectedNumberChar, skipChildren`

    - ### Methods inherited from class com.fasterxml.jackson.core.JsonParser

      `_codec, _constructError, _reportUnsupportedOperation, canParseAsync, canReadObjectId, canReadTypeId, canUseSchema, configure, currentName, disable, enable, getBinaryValue, getBooleanValue, getByteValue, getCurrentValue, getFeatureMask, getNonBlockingInputFeeder, getObjectId, getSchema, getShortValue, getTypeId, getValueAsBoolean, getValueAsDouble, isEnabled, isEnabled, overrideFormatFeatures, overrideStdFeatures, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, requiresCustomCodec, setCurrentValue, setFeatureMask, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError, setSchema`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _objectCodec

          protected com.fasterxml.jackson.core.ObjectCodec _objectCodec

      Codec used for data binding when (if) requested.

    - #### _ioContext

          protected final com.fasterxml.jackson.core.io.IOContext _ioContext

      I/O context for this reader. It handles buffer allocation for the reader.

    - #### _closed

          protected boolean _closed

      Flag that indicates whether parser is closed or not. Gets set when parser is either closed by explicit call (`close()`) or when end-of-input is reached.

    - #### _inputPtr

          protected int _inputPtr

      Pointer to next available character in buffer

    - #### _inputEnd

          protected int _inputEnd

      Index of character after last available one in the buffer.

    - #### _currInputProcessed

          protected long _currInputProcessed

      Number of characters/bytes that were contained in previous blocks (blocks that were already processed prior to the current buffer).

    - #### _currInputRow

          protected int _currInputRow

      Current row location of current point in input buffer, starting from 1, if available.

    - #### _currInputRowStart

          protected int _currInputRowStart

      Current index of the first character of the current row in input buffer. Needed to calculate column position, if necessary; benefit of not having column itself is that this only has to be updated once per line.

    - #### _tokenInputTotal

          protected long _tokenInputTotal

      Total number of bytes/characters read before start of current token. For big (gigabyte-sized) sizes are possible, needs to be long, unlike pointers and sizes related to in-memory buffers.

    - #### _tokenInputRow

          protected int _tokenInputRow

      Input row on which current token starts, 1-based

    - #### _tokenInputCol

          protected int _tokenInputCol

      Column on input row that current token starts; 0-based (although in the end it'll be converted to 1-based)

    - #### _parsingContext

          protected CBORReadContext _parsingContext

      Information about parser context, context in which the next token is to be parsed (root, array, object).

    - #### _textBuffer

          protected final com.fasterxml.jackson.core.util.TextBuffer _textBuffer

      Buffer that contains contents of String values, including field names if necessary (name split across boundary, contains escape sequence, or access needed to char array)

    - #### _nameCopyBuffer

          protected char[] _nameCopyBuffer

      Temporary buffer that is needed if field name is accessed using `getTextCharacters()` method (instead of String returning alternatives)

    - #### _nameCopied

          protected boolean _nameCopied

      Flag set to indicate whether the field name is available from the name copy buffer or not (in addition to its String representation being available via read context)

    - #### _byteArrayBuilder

          protected com.fasterxml.jackson.core.util.ByteArrayBuilder _byteArrayBuilder

      ByteArrayBuilder is needed if 'getBinaryValue' is called. If so, we better reuse it for remainder of content.

    - #### _binaryValue

          protected byte[] _binaryValue

      We will hold on to decoded binary data, for duration of current event, so that multiple calls to `getBinaryValue(com.fasterxml.jackson.core.Base64Variant)` will not need to decode data more than once.

    - #### _tagValue

          protected int _tagValue

      We will keep track of tag value for possible future use.

    - #### _inputStream

          protected InputStream _inputStream

      Input stream that can be used for reading more content, if one in use. May be null, if input comes just as a full buffer, or if the stream has been closed.

    - #### _inputBuffer

          protected byte[] _inputBuffer

      Current buffer from which data is read; generally data is read into buffer from input source, but in some cases pre-loaded buffer is handed to the parser.

    - #### _bufferRecyclable

          protected boolean _bufferRecyclable

      Flag that indicates whether the input buffer is recycable (and needs to be returned to recycler once we are done) or not.

      If it is not, it also means that parser can NOT modify underlying buffer.

    - #### _tokenIncomplete

          protected boolean _tokenIncomplete

      Flag that indicates that the current token has not yet been fully processed, and needs to be finished for some access (or skipped to obtain the next token)

    - #### _typeByte

          protected int _typeByte

      Type byte of the current token

    - #### _symbols

          protected final com.fasterxml.jackson.core.sym.ByteQuadsCanonicalizer _symbols

      Symbol table that contains field names encountered so far

    - #### _quadBuffer

          protected int[] _quadBuffer

      Temporary buffer used for name parsing.

    - #### _quad1

          protected int _quad1

      Quads used for hash calculation

    - #### _quad2

          protected int _quad2

      Quads used for hash calculation

    - #### _quad3

          protected int _quad3

      Quads used for hash calculation

    - #### _numTypesValid

          protected int _numTypesValid

      Bitfield that indicates which numeric representations have been calculated for the current type

    - #### _numberInt

          protected int _numberInt

    - #### _numberLong

          protected long _numberLong

    - #### _numberFloat

          protected float _numberFloat

    - #### _numberDouble

          protected double _numberDouble

    - #### _numberBigInt

          protected BigInteger _numberBigInt

    - #### _numberBigDecimal

          protected BigDecimal _numberBigDecimal

  - ### Constructor Detail

    - #### CBORParser

          public CBORParser(com.fasterxml.jackson.core.io.IOContext ctxt,
                            int parserFeatures,
                            int cborFeatures,
                            com.fasterxml.jackson.core.ObjectCodec codec,
                            com.fasterxml.jackson.core.sym.ByteQuadsCanonicalizer sym,
                            InputStream in,
                            byte[] inputBuffer,
                            int start,
                            int end,
                            boolean bufferRecyclable)

  - ### Method Detail

    - #### getCodec

          public com.fasterxml.jackson.core.ObjectCodec getCodec()

      Specified by:
        `getCodec` in class `com.fasterxml.jackson.core.JsonParser`

    - #### setCodec

          public void setCodec(com.fasterxml.jackson.core.ObjectCodec c)

      Specified by:
        `setCodec` in class `com.fasterxml.jackson.core.JsonParser`

    - #### version

          public com.fasterxml.jackson.core.Version version()

      Specified by:
        `version` in interface `com.fasterxml.jackson.core.Versioned`
      Specified by:
        `version` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getFormatFeatures

          public int getFormatFeatures()

      Overrides:
        `getFormatFeatures` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getCurrentTag

          public int getCurrentTag()

      Method that can be used to access tag id associated with the most recently decoded value (whether completely, for scalar values, or partially, for Objects/Arrays), if any. If no tag was associated with it, -1 is returned.
      Since:
        2.5

    - #### releaseBuffered

          public int releaseBuffered(OutputStream out)
                              throws IOException

      Overrides:
        `releaseBuffered` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getInputSource

          public Object getInputSource()

      Overrides:
        `getInputSource` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getTokenLocation

          public com.fasterxml.jackson.core.JsonLocation getTokenLocation()

      Overridden since we do not really have character-based locations, but we do have byte offset to specify.
      Specified by:
        `getTokenLocation` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getCurrentLocation

          public com.fasterxml.jackson.core.JsonLocation getCurrentLocation()

      Overridden since we do not really have character-based locations, but we do have byte offset to specify.
      Specified by:
        `getCurrentLocation` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getCurrentName

          public String getCurrentName()
                                throws IOException

      Method that can be called to get the name associated with the current event.
      Specified by:
        `getCurrentName` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### overrideCurrentName

          public void overrideCurrentName(String name)

      Specified by:
        `overrideCurrentName` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### isClosed

          public boolean isClosed()

      Specified by:
        `isClosed` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### getParsingContext

          public CBORReadContext getParsingContext()

      Specified by:
        `getParsingContext` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### hasTextCharacters

          public boolean hasTextCharacters()

      Specified by:
        `hasTextCharacters` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`

    - #### _releaseBuffers

          protected void _releaseBuffers()
                                  throws IOException

      Method called to release internal buffers owned by the base reader. This may be called along with `_closeInput()` (for example, when explicitly closing this reader instance), or separately (if need be).
      Throws:
        `IOException`

    - #### nextToken

          public com.fasterxml.jackson.core.JsonToken nextToken()
                                                         throws IOException

      Specified by:
        `nextToken` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### _numberToName

          protected String _numberToName(int ch,
                                         boolean neg)
                                  throws IOException

      Throws:
        `IOException`

    - #### _handleTaggedBinary

          protected com.fasterxml.jackson.core.JsonToken _handleTaggedBinary(int tag)
                                                                      throws IOException

      Throws:
        `IOException`

    - #### _handleTaggedArray

          protected com.fasterxml.jackson.core.JsonToken _handleTaggedArray(int tag,
                                                                            int len)
                                                                     throws IOException

      Throws:
        `IOException`

    - #### finishToken

          public void finishToken()
                           throws IOException

      Method for forcing full read of current token, even if it might otherwise only be read if data is accessed via `getText()` and similar methods.
      Overrides:
        `finishToken` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### nextFieldName

          public boolean nextFieldName(com.fasterxml.jackson.core.SerializableString str)
                                throws IOException

      Overrides:
        `nextFieldName` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### nextFieldName

          public String nextFieldName()
                               throws IOException

      Overrides:
        `nextFieldName` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### nextTextValue

          public String nextTextValue()
                               throws IOException

      Overrides:
        `nextTextValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### nextIntValue

          public int nextIntValue(int defaultValue)
                           throws IOException

      Overrides:
        `nextIntValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### nextLongValue

          public long nextLongValue(long defaultValue)
                             throws IOException

      Overrides:
        `nextLongValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### nextBooleanValue

          public Boolean nextBooleanValue()
                                   throws IOException

      Overrides:
        `nextBooleanValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getText

          public String getText()
                         throws IOException

      Method for accessing textual representation of the current event; if no current event (before first call to `nextToken()`, or after encountering end-of-input), returns null. Method can be called for any event.
      Specified by:
        `getText` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getTextCharacters

          public char[] getTextCharacters()
                                   throws IOException

      Specified by:
        `getTextCharacters` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getTextLength

          public int getTextLength()
                            throws IOException

      Specified by:
        `getTextLength` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getTextOffset

          public int getTextOffset()
                            throws IOException

      Specified by:
        `getTextOffset` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getValueAsString

          public String getValueAsString()
                                  throws IOException

      Overrides:
        `getValueAsString` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getValueAsString

          public String getValueAsString(String defaultValue)
                                  throws IOException

      Overrides:
        `getValueAsString` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getText

          public int getText(Writer writer)
                      throws IOException

      Overrides:
        `getText` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getBinaryValue

          public byte[] getBinaryValue(com.fasterxml.jackson.core.Base64Variant b64variant)
                                throws IOException

      Specified by:
        `getBinaryValue` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `IOException`

    - #### getEmbeddedObject

          public Object getEmbeddedObject()
                                   throws IOException

      Overrides:
        `getEmbeddedObject` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### readBinaryValue

          public int readBinaryValue(com.fasterxml.jackson.core.Base64Variant b64variant,
                                     OutputStream out)
                              throws IOException

      Overrides:
        `readBinaryValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### isNaN

          public boolean isNaN()

      Overrides:
        `isNaN` in class `com.fasterxml.jackson.core.JsonParser`

    - #### getNumberValue

          public Number getNumberValue()
                                throws IOException

      Specified by:
        `getNumberValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getNumberType

          public com.fasterxml.jackson.core.JsonParser.NumberType getNumberType()
                                                                         throws IOException

      Specified by:
        `getNumberType` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getIntValue

          public int getIntValue()
                          throws IOException

      Specified by:
        `getIntValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getLongValue

          public long getLongValue()
                            throws IOException

      Specified by:
        `getLongValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getBigIntegerValue

          public BigInteger getBigIntegerValue()
                                        throws IOException

      Specified by:
        `getBigIntegerValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getFloatValue

          public float getFloatValue()
                              throws IOException

      Specified by:
        `getFloatValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getDoubleValue

          public double getDoubleValue()
                                throws IOException

      Specified by:
        `getDoubleValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### getDecimalValue

          public BigDecimal getDecimalValue()
                                     throws IOException

      Specified by:
        `getDecimalValue` in class `com.fasterxml.jackson.core.JsonParser`
      Throws:
        `IOException`

    - #### _checkNumericValue

          protected void _checkNumericValue(int expType)
                                     throws IOException

      Throws:
        `IOException`

    - #### convertNumberToInt

          protected void convertNumberToInt()
                                     throws IOException

      Throws:
        `IOException`

    - #### convertNumberToLong

          protected void convertNumberToLong()
                                      throws IOException

      Throws:
        `IOException`

    - #### convertNumberToBigInteger

          protected void convertNumberToBigInteger()
                                            throws IOException

      Throws:
        `IOException`

    - #### convertNumberToFloat

          protected void convertNumberToFloat()
                                       throws IOException

      Throws:
        `IOException`

    - #### convertNumberToDouble

          protected void convertNumberToDouble()
                                        throws IOException

      Throws:
        `IOException`

    - #### convertNumberToBigDecimal

          protected void convertNumberToBigDecimal()
                                            throws IOException

      Throws:
        `IOException`

    - #### _finishToken

          protected void _finishToken()
                               throws IOException

      Method called to finish parsing of a token so that token contents are retriable
      Throws:
        `IOException`

    - #### _finishTextToken

          protected String _finishTextToken(int ch)
                                     throws IOException

      Throws:
        `IOException`
      Since:
        2.6

    - #### _finishBytes

          protected byte[] _finishBytes(int len)
                                 throws IOException

      Throws:
        `IOException`

    - #### _decodeFieldName

          protected final com.fasterxml.jackson.core.JsonToken _decodeFieldName()
                                                                         throws IOException

      Throws:
        `IOException`

    - #### _decodeNonStringName

          protected final void _decodeNonStringName(int ch)
                                             throws IOException

      Method that handles initial token type recognition for token that has to be either FIELD_NAME or END_OBJECT.
      Throws:
        `IOException`

    - #### _skipIncomplete

          protected void _skipIncomplete()
                                  throws IOException

      Method called to skip remainders of an incomplete token, when contents themselves will not be needed any more. Only called or byte array and text.
      Throws:
        `IOException`

    - #### _skipChunked

          protected void _skipChunked(int expectedType)
                               throws IOException

      Throws:
        `IOException`

    - #### _skipBytesL

          protected void _skipBytesL(long llen)
                              throws IOException

      Throws:
        `IOException`

    - #### _skipBytes

          protected void _skipBytes(int len)
                             throws IOException

      Throws:
        `IOException`

    - #### _decodeUndefinedValue

          protected com.fasterxml.jackson.core.JsonToken _decodeUndefinedValue()
                                                                        throws IOException

      Helper method to encapsulate details of handling of mysterious `undefined` value that is allowed to be used as something encoder could not handle (as per spec), whatever the heck that should be. Current definition for 2.9 is that we will be return `JsonToken.VALUE_NULL`, but for later versions it is likely that we will alternatively allow decoding as `JsonToken.VALUE_EMBEDDED_OBJECT` with "embedded value" of `null`.
      Throws:
        `IOException`
      Since:
        2.9.6

    - #### loadMore

          protected final boolean loadMore()
                                    throws IOException

      Throws:
        `IOException`

    - #### loadMoreGuaranteed

          protected final void loadMoreGuaranteed()
                                           throws IOException

      Throws:
        `IOException`

    - #### _loadToHaveAtLeast

          protected final void _loadToHaveAtLeast(int minAvailable)
                                           throws IOException

      Helper method that will try to load at least specified number bytes in input buffer, possible moving existing data around if necessary
      Throws:
        `IOException`

    - #### _getByteArrayBuilder

          protected com.fasterxml.jackson.core.util.ByteArrayBuilder _getByteArrayBuilder()

    - #### _closeInput

          protected void _closeInput()
                              throws IOException

      Throws:
        `IOException`

    - #### _handleEOF

          protected void _handleEOF()
                             throws com.fasterxml.jackson.core.JsonParseException

      Specified by:
        `_handleEOF` in class `com.fasterxml.jackson.core.base.ParserMinimalBase`
      Throws:
        `com.fasterxml.jackson.core.JsonParseException`

    - #### _handleCBOREOF

          protected com.fasterxml.jackson.core.JsonToken _handleCBOREOF()
                                                                 throws IOException

      Throws:
        `IOException`

    - #### _invalidToken

          protected void _invalidToken(int ch)
                                throws com.fasterxml.jackson.core.JsonParseException

      Throws:
        `com.fasterxml.jackson.core.JsonParseException`

    - #### _reportUnexpectedBreak

          protected void _reportUnexpectedBreak()
                                         throws IOException

      Throws:
        `IOException`

    - #### _reportInvalidChar

          protected void _reportInvalidChar(int c)
                                     throws com.fasterxml.jackson.core.JsonParseException

      Throws:
        `com.fasterxml.jackson.core.JsonParseException`

    - #### _reportInvalidInitial

          protected void _reportInvalidInitial(int mask)
                                        throws com.fasterxml.jackson.core.JsonParseException

      Throws:
        `com.fasterxml.jackson.core.JsonParseException`

    - #### _reportInvalidOther

          protected void _reportInvalidOther(int mask)
                                      throws com.fasterxml.jackson.core.JsonParseException

      Throws:
        `com.fasterxml.jackson.core.JsonParseException`

    - #### _reportInvalidOther

          protected void _reportInvalidOther(int mask,
                                             int ptr)
                                      throws com.fasterxml.jackson.core.JsonParseException

      Throws:
        `com.fasterxml.jackson.core.JsonParseException`

Copyright © 2019 FasterXML. All rights reserved.